-----------------------------------------------------------------------------------------------
-- Client Lua Script for BensBAM
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
require "ChatSystemLib"
 
-----------------------------------------------------------------------------------------------
-- BensBAM Module Definition
-----------------------------------------------------------------------------------------------
local BensBAM = {} 
BensBAM.maxHealCrit = 0
BensBAM.maxDmgCrit = 0
local tBensBAMsSettings = {
	"MaxHit",
	"MaxHeal",
	"AllHit",
	"AllHeal",
	"NmbHeal",
	"NmbHit",
	"ChannelToPost",
	"EveryHit",
	"EveryHeal"
}
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function BensBAM:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function BensBAM:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
	BensBAM.maxHealCrit = 0
	BensBAM.maxDmgCrit = 0
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- BensBAM OnLoad
-----------------------------------------------------------------------------------------------
function BensBAM:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("BensBAM.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- BensBAM OnDocLoaded
-----------------------------------------------------------------------------------------------
function BensBAM:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "BensBAMForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)
	
		Apollo.RegisterEventHandler("DamageOrHealingDone",				 		"OnDamageOrHealing", self)
		Apollo.RegisterSlashCommand("bam", 				"OnBAMOn", self)
		self.tUI = {}
		self.tUI.Channel = self.wndMain:FindChild("Channel")
		self.tUI.MaxDMG = self.wndMain:FindChild("MaxDmg")
		self.tUI.MaxHeal = self.wndMain:FindChild("MaxHeal")
		self.tUI.AvgDMG = self.wndMain:FindChild("AvgDmg")
		self.tUI.AvgHeal = self.wndMain:FindChild("AvgHeal")
		self.tUI.SumDMG = self.wndMain:FindChild("SumDmg")
		self.tUI.SumHeal = self.wndMain:FindChild("SumHeal")
		self.tUI.ChanceHeal = self.wndMain:FindChild("ChanceHeal")
		self.tUI.ChanceDmg = self.wndMain:FindChild("ChanceDmg")
		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)


		-- Do additional Addon initialization here
		  Print("[BensBAM] This Addon is discontinued due to me quit playing. Feel free to take it over.")
	end
end

function BensBAM:OnDamageOrHealing(unitCaster, unitTarget, eDamageType, nDamage, nShieldDamaged, nAbsorptionAmount, bCritical )
	if unitTarget == nil then
		return
	end
	if not self.restored then
		self:DefaultSettings()
	end
	if self.maxHeal == nil then self.maxHeal = 0 end
	if self.maxHit == nil then self.maxHit = 0 end
	if GameLib.IsControlledUnit(unitTarget) or unitTarget:IsMounted() then
		if eDamageType == GameLib.CodeEnumDamageType.Heal or eDamageType == GameLib.CodeEnumDamageType.HealShields then

		else

		end	
	end
	if GameLib.IsControlledUnit(unitCaster) then
		if eDamageType == GameLib.CodeEnumDamageType.Heal or eDamageType == GameLib.CodeEnumDamageType.HealShields then
			self.EveryHeal = self.EveryHeal + 1
			if bCritical == true then
				-- Print("Outgoing Crit Heal"..nDamage)
				ChatSystemLib.Command("/" .. self.ChannelToPost .. " MAB with " .. nDamage.." Heal") --on ".. GameLib.unitTarget) 
				self.AllHeal = nDamage + self.AllHeal
				self.NmbHeal = 1 + self.NmbHeal 
				if nDamage < 9001 then 
					Sound.PlayFile("bam.wav");
				else
					Sound.PlayFile("baam.wav");
				end
				if nDamage > self.maxHeal then
					self.maxHeal = nDamage
					Print("New Max Heal Crit: "..self.maxHeal)
				end
			end
		else
			self.EveryHit = self.EveryHit + 1
			if bCritical == true then
				-- Print("Outgoing Crit"..nDamage)
				self.AllHit = nDamage + self.AllHit
				self.NmbHit = 1 + self.NmbHit
				ChatSystemLib.Command("/" .. self.ChannelToPost .. " BAM with " .. nDamage.." Dmg") -- on ".. unitTarget) 
				if nDamage < 9001 then 
					Sound.PlayFile("bam.wav");
				else
					Sound.PlayFile("baam.wav");
				end
				if nDamage > self.maxHit then
					self.maxHit = nDamage
					Print("New Max Crit: "..self.maxHit)
				end
			end
		end	

	end
end

-----------------------------------------------------------------------------------------------
-- BensBAM Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-----------------------------------------------------------------------------------------------
-- Load and Save
-----------------------------------------------------------------------------------------------
-- Restore Saved User Settings
function BensBAM:OnRestore(eType, t)
	if eType ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
	
	for idx,property in ipairs(tBensBAMsSettings) do
		if t[property] ~= nil then self[property] = t[property] end
	end
	
	self.restored = true
end

-- Save User Settings
function BensBAM:OnSave(eType)
	if eType ~= GameLib.CodeEnumAddonSaveLevel.Character then return end

	local tSave = {}
	for idx,property in ipairs(tBensBAMsSettings) do tSave[property] = self[property] end
	
	return tSave
end

-----------------------------------------------------------------------------------------------
-- BensBAMForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function BensBAM:OnOK()
	self.ChannelToPost = self.tUI.Channel:GetText()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function BensBAM:OnCancel()
	self.wndMain:Close() -- hide the window
end

function BensBAM:OnBAMOn()
	if not self.restored then
		self:DefaultSettings()
	end
	AvgDmg = 0
	ChanceDamage = 0
	if self.NmbHit > 0 then
		AvgDmg = math.floor(self.AllHit / self.NmbHit)
		ChanceDamage = math.floor((self.NmbHit / self.EveryHit) * 100)
	end
	AvgHeal = 0
	ChanceHeal = 0
	if self.NmbHeal > 0 then
	 	AvgHeal = math.floor(self.AllHeal / self.NmbHeal)
		ChanceHeal = math.floor((self.NmbHeal / self.EveryHeal ) * 100)
	end
	self.tUI.Channel:SetText(self.ChannelToPost)
	self.tUI.MaxDMG:SetText(self.maxHit) 
	self.tUI.MaxHeal:SetText(self.maxHeal)
	self.tUI.AvgDMG:SetText(AvgDmg)
	self.tUI.AvgHeal:SetText(AvgHeal)
	self.tUI.SumDMG:SetText(self.AllHit)
	self.tUI.SumHeal:SetText(self.AllHeal)
	self.tUI.ChanceDmg:SetText(ChanceDamage)
	self.tUI.ChanceHeal:SetText(ChanceHeal)
	self.wndMain:Invoke()
end

function BensBAM:DefaultSettings()
	self.ChannelToPost = ""
	self.maxHit = 0
	self.maxHeal = 0
	self.AllHit = 0
	self.AllHeal = 0
	self.NmbHit = 0
	self.NmbHeal = 0
	self.EveryHit = 0
	self.EveryHeal = 0
	self.restored = true
end
-----------------------------------------------------------------------------------------------
-- BensBAM Instance
-----------------------------------------------------------------------------------------------
local BensBAMInst = BensBAM:new()
BensBAMInst:Init()
